﻿using System;
using System.Collections.Generic;
using EonaCat.Quic.Helpers;

namespace EonaCat.Quic.Infrastructure.Frames
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.
    public class DataBlockedFrame : Frame
    {
        public override byte Type => 0x14;
        public IntegerVar MaximumData { get; set; }

        public DataBlockedFrame()
        {
        }

        public DataBlockedFrame(UInt64 dataLimit)
        {
            MaximumData = dataLimit;
        }

        public override void Decode(ByteArray array)
        {
            byte type = array.ReadByte();
            MaximumData = array.ReadIntegerVar();
        }

        public override byte[] Encode()
        {
            List<byte> result = new List<byte>();
            result.Add(Type);
            result.AddRange(MaximumData.ToByteArray());

            return result.ToArray();
        }
    }
}