﻿using System;
using System.Collections.Generic;
using EonaCat.Quic.Helpers;

namespace EonaCat.Quic.Infrastructure.Frames
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.
    public class MaxStreamsFrame : Frame
    {
        public override byte Type => 0x12;
        public IntegerVar MaximumStreams { get; set; }

        public MaxStreamsFrame()
        {
        }

        public MaxStreamsFrame(UInt64 maximumStreamId, StreamType appliesTo)
        {
            MaximumStreams = new IntegerVar(maximumStreamId);
        }

        public override void Decode(ByteArray array)
        {
            byte type = array.ReadByte();
            MaximumStreams = array.ReadIntegerVar();
        }

        public override byte[] Encode()
        {
            List<byte> result = new List<byte>();

            result.Add(Type);
            result.AddRange(MaximumStreams.ToByteArray());

            return result.ToArray();
        }
    }
}