﻿using System.Collections.Generic;
using EonaCat.Quic.Helpers;

namespace EonaCat.Quic.Infrastructure.Frames
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    public class ResetStreamFrame : Frame
    {
        public override byte Type => 0x04;
        public IntegerVar StreamId { get; set; }
        public IntegerVar ApplicationProtocolErrorCode { get; set; }
        public IntegerVar FinalSize { get; set; }

        public override void Decode(ByteArray array)
        {
            byte type = array.ReadByte();
            StreamId = array.ReadIntegerVar();
            ApplicationProtocolErrorCode = array.ReadIntegerVar();
            FinalSize = array.ReadIntegerVar();
        }

        public override byte[] Encode()
        {
            List<byte> result = new List<byte>();

            result.Add(Type);
            result.AddRange(StreamId.ToByteArray());
            result.AddRange(ApplicationProtocolErrorCode.ToByteArray());
            result.AddRange(FinalSize.ToByteArray());

            return result.ToArray();
        }
    }
}