﻿using System;
using EonaCat.Json;

namespace EonaCat.Network
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    internal class SerializationHelper
    {
        internal static T DeserializeJson<T>(string json)
        {
            if (String.IsNullOrEmpty(json))
                throw new ArgumentNullException(nameof(json));
            return JsonHelper.ToObject<T>(json);
        }

        internal static string SerializeJson(object obj, bool pretty)
        {
            if (obj == null)
                return null;
            string json;

            if (pretty)
            {
                json = JsonHelper.ToJson(obj,
                    Formatting.Indented,
                    new JsonSerializerSettings
                    {
                        NullValueHandling = NullValueHandling.Ignore,
                        DateTimeZoneHandling = DateTimeZoneHandling.Local,
                    });
            }
            else
            {
                json = JsonHelper.ToJson(obj,
                    new JsonSerializerSettings
                    {
                        NullValueHandling = NullValueHandling.Ignore,
                        DateTimeZoneHandling = DateTimeZoneHandling.Local
                    });
            }

            return json;
        }
    }
}